# -*- coding: utf-8 -*-
"""
Created on Mon Jan  9 11:12:29 2017
This script contains a loop to go over all videos from table 1 and for each, generate
individual plots, e.g. the trajectory, the simplified trajectory, the cdf of 
distances to the wall, etc.

@author: haenzi
"""
import numpy as np
import cv2
from matplotlib import pyplot as plt
import os
from os import path
import pandas as pd
import time
import statsmodels.api as sm
import datetime as dt
#from mpl_toolkits.mplot3d import Axes3D
from scipy import signal
from scipy.stats import linregress
from rdp import rdp
import pycircstat as circ
from matplotlib import cm

runfile('D:/SH data/thigmo/python scripts/openCVtutorialUtils.py', wdir='D:/SH data/thigmo/python scripts')
runfile('D:/SH data/thigmo/python scripts/newThigmoTrackingFunctions.py', wdir='D:/SH data/thigmo/python scripts')
runfile('D:/SH data/thigmo/python scripts/plottingUtilities.py', wdir='D:/SH data/thigmo/python scripts')

# hardcoded folder locations
thigmoPath = 'D:\\SH data\\thigmo'
baseImageCheck = 'Y:\\Backup stuff\\Data\\SH data\\thigmoTrackingCheck' #'D:\\SH data\\thigmo\\analysis\\trackingCheck'
savePath = 'D:\\SH data\\thigmo\\analysis'
savePathOriginals = 'D:\\SH data\\thigmo\\analysis\\originalDFs'
basePlots = 'D:\\SH data\\thigmo\\analysis\\plots'
timestampPath = 'Y:\\Backup stuff\\Data\\SH data\\thigmo\\analysis\\timestamps'

# read level1 file
os.chdir(thigmoPath)
level1 = pd.read_csv('thigmoOverviewForPandas.csv')
level1 = level1.set_index('pythonIndex')
corrections = np.load('corrections.npy').item()

for level1Index in np.arange(0, len(level1)):

    if level1.exclude[level1Index] == 1:
        continue
    
    df, reduced = individualPlots(level1, level1Index, corrections, thigmoPath, baseImageCheck, savePath, 
                    savePathOriginals, basePlots, timestampPath)