# -*- coding: utf-8 -*-
"""
Created on Wed Dec 21 13:29:16 2016
This script contains code to read some video, warp and crop it to the tank,
and save the cropped images again.

@author: haenzi
"""

import numpy as np
import cv2
from matplotlib import pyplot as plt
import os
from os import path
import pandas as pd
import time
import statsmodels.api as sm
import datetime as dt
#from mpl_toolkits.mplot3d import Axes3D
from scipy import signal
from scipy.stats import linregress
from rdp import rdp
import pycircstat as circ

runfile('D:/SH data/thigmo/python scripts/openCVtutorialUtils.py', wdir='D:/SH data/thigmo/python scripts')
runfile('D:/SH data/thigmo/python scripts/newThigmoTrackingFunctions.py', wdir='D:/SH data/thigmo/python scripts')

# hardcoded folder locations
thigmoPath = 'D:\\SH data\\thigmo'
baseImageCheck = 'Y:\\Backup stuff\\Data\\SH data\\thigmoTrackingCheck' #'D:\\SH data\\thigmo\\analysis\\trackingCheck'
savePathOriginals = 'D:\\SH data\\thigmo\\analysis\\originalDFs'
basePlots = 'D:\\SH data\\thigmo\\analysis\\plots'
examplePath = 'Y:\\Backup stuff\\Data\\SH data\\thigmoExamples'

# read level1 file
os.chdir(thigmoPath)
level1 = pd.read_csv('thigmoOverviewForPandas.csv')
level1 = level1.set_index('pythonIndex')

#exampleIndices = [6, 50, 77, 5, 27, 29, 33, 58, 65, 9, 15, 86, 89, 93, 21]
exampleIndices = [7, 11]

for level1Index in exampleIndices:
    
    print('working on index ', level1Index)
    print('filename: ', level1.Filename[level1Index])
    
    # get data folder
    dataPath = path.join(level1.Path[level1Index], level1.Filename[level1Index])
    
    # get or make folder to put the images to check the tracking
    exampleSaveFolder = path.join(examplePath, level1.Filename[level1Index] + '_warp')
    if path.exists(exampleSaveFolder):
        continue
    else:
        os.mkdir(exampleSaveFolder)
    os.chdir(exampleSaveFolder)
        
    # reconstruct warpMatrix, maxWidth and maxHeight from tankCorners
    tankCorners = [[0, 0], [0, 0], [0, 0], [0, 0]]
    tankCorners[0][0] = level1.tank0x[level1Index]
    tankCorners[0][1] = level1.tank0y[level1Index]
    tankCorners[1][0] = level1.tank1x[level1Index]
    tankCorners[1][1] = level1.tank1y[level1Index]
    tankCorners[2][0] = level1.tank2x[level1Index]
    tankCorners[2][1] = level1.tank2y[level1Index]
    tankCorners[3][0] = level1.tank3x[level1Index]
    tankCorners[3][1] = level1.tank3y[level1Index]
    warpMatrix, maxWidth, maxHeight = reconstructWarp(tankCorners)
        
    # get the image list and sort it
    imList = os.listdir(dataPath)
    if len(imList) > 9999:
        imList = sorted(imList, key=lambda im: int(im[(im.rfind('-') + 1):im.rfind('.')]))
    else:
        imList.sort()
      
    t1 = time.time()
    # loop through all the images  
    for index,im in enumerate(imList[0:(len(imList))]):
        if np.mod(index, 1000) == 0:
            print('currently at frame ', index)
            
        # for the videos with 18000 frames, only take every other one
        if len(imList)>9999 and np.mod(index, 2) == 1:
            continue
        
        # load
        imPath = path.join(dataPath, im)
        img = cv2.imread(imPath,0)
        
        # warp
        warp = cv2.warpPerspective(img, warpMatrix, (maxWidth, maxHeight))
        
        # save image
        cv2.imwrite('im'+str(index)+'.tif', warp)
    
    
    t2 = time.time()
    elapsed = t2-t1
    print(elapsed)
    